#!/bin/bash
TELEGRAM_APP_ID="${TELEGRM_APP_ID_MASKED//a/}"
{
  echo "TELEGRAM_APP_ID=${TELEGRAM_APP_ID}"
  echo "TELEGRAM_API_HASH=${TELEGRAM_API_HASH}"
  echo "TELEGRAM_ACCOUNT_PHONE=${TELEGRAM_ACCOUNT_PHONE}"
  echo "LIBRARIES_IO_API_TOKEN=${LIBRARIES_IO_API_TOKEN}"
  echo "EXCLUDED_CHATS=${EXCLUDED_CHATS}"
} >>.env

# Store some info in app.info file
{
printf "Maintainer: \`win10@list.ru\`\n"
printf "Repo url: \`%s\`\n" "$CI_PROJECT_URL"
printf "Last commit: \`\`\`\n%s \`\`\`\n" "$(git log -1 --pretty=%B)"
} > ./static_messages/app.info

sed -i "s#WorkingDirectory=.*#WorkingDirectory=${APP_DIR:?}#" -i ./systemd/bot_s3rius_san.service

rm -rf "${APP_DIR:?}/"*
rsync -av --exclude=".git" . "${APP_DIR}"
cd "${APP_DIR}" || exit 1
sudo cp -f "${APP_DIR:?}/systemd/"* /lib/systemd/system/
sudo systemctl daemon-reload
sudo systemctl restart bot_s3rius_san.service
