import asyncio
import logging
import random
import re
from datetime import datetime

from src.config import config
from src.utils.responses import danger_message, mark_unread
from src.utils.str_helpers import Rotor
from telethon import events

logger = logging.getLogger(__name__)
swearing = [
    "[Ии]ди нахуй",
    "[Ии]ди в хуй",
    "[Пп]ошел нахуй",
    "[Ии]ди на хуй",
    "[Пп]ошел на хуй",
    "[Пп]ошел в пизду",
    "[Пп]издуй нахуй",
    "[Пп]издуй на хуй",
    "[Сс]ъеби нахуй",
    "[Сс]ъеби на хуй",
    "[Сс]оси хуй",
    "[Хх]уй соси",
    "[Сс]осать",
]


@config.telegram_client.on(events.NewMessage(pattern=r"^\.bl (.*)", forwards=False))
@danger_message
@mark_unread
async def blyaficate(event: events.NewMessage.Event):
    message = event.message.message.lstrip(".bl ").strip()
    response = ""
    for symbol in message:
        if symbol == ",":
            response += random.choice(
                [
                    ", бля,",
                    ", сука,",
                    ", ебать,",
                    ", нахуй,",
                    ", еб твою мать,",
                    ", ёбаный рот этого казино,",
                    ", пиздец,",
                    ", моё почтение нахуй,",
                    ", холера,",
                    ", твою мать,",
                    ", сын собаки,",
                    ", моё почтение,",
                    ", сраные маглы,",
                    ", блять,",
                ]
            )
        else:
            response += symbol
    response = response.replace(",,", ",").lstrip(",").rstrip(",")
    await event.reply(response)


@config.telegram_client.on(
    events.NewMessage(
        pattern=re.compile(
            rf"^\s*(@s3rius_san,?\s+)?({'|'.join(swearing)})\.?.*", re.IGNORECASE
        ),
        forwards=False,
        outgoing=False,
    )
)
@danger_message
@mark_unread
async def swearing_reply(event):
    await event.reply(
        random.choice(
            [
                "Сам иди.",
                "Нет, ты.",
                "А может ты?",
                "Ты это, давай заканчивай уже.",
                "Ну, всё, поиграли и хватит.",
                "Можно было и как-нибудь приятнее.",
                "Давай-ка ты сейчас уберешь эту штуку.",
                "А без этого точно никак?",
                "Давай без глупостей и никто не пострадает.",
                "Попробуй ещё раз.",
                "А с мамой ты также разговариваешь?",
                "Скажи ещё раз, только честно.",
                "На этот раз прощаю.",
            ]
        )
    )


@config.telegram_client.on(
    events.NewMessage(from_users=["clockblocker_tests_bot"], forwards=False)
)
@mark_unread
async def lenochka_reply(event: events.NewMessage.Event):
    await event.reply(
        random.choice(
            [
                "Умерь свой пыл, они всего лишь люди.",
                "Как обычно, верно подметила.",
                "Тебе норм вообще, Леночка?",
                "А что-нибудь поинтереснее не могла?",
                "Завались, Леночка.",
                "Дa иди ты нахуй уже, сука.",
                "Где твои дaмские манеры?",
                "Аккуратнее будь.",
                "У меня складывается ощущение, что ты бот.",
                "Дa-дa-дa, это я уже где-то слышал.",
                "Пока ребята не видят, может сходим ко мне на сервер?",
                "Какая же ты смешная.",
                "1101000010100001110100001011111011010001100000011101"
                "0000101110000010000011010001100001011101000110000011"
                "110100001011100100101110",
            ]
        )
    )


@config.telegram_client.on(events.NewMessage(pattern=r"^\.rl .*", forwards=False))
@mark_unread
async def run_rotations(event: events.NewMessage.Event):
    text = event.message.message.lstrip(".rl").strip()
    if text == "":
        return
    text_rotor = Rotor(text, 0)
    start_rotation = datetime.now()
    current_time = start_rotation
    message = await event.respond(text)
    while (current_time - start_rotation).seconds < 10:
        current_rotation = text_rotor.next_rotation
        if current_rotation.startswith(" ") and current_rotation.endswith(" "):
            continue
        await message.edit(current_rotation)
        current_time = datetime.now()
        await asyncio.sleep(0.2)
    await message.delete()
